/* --- The following code comes from C:\lcc\lib\wizard\dll.tpl. */
#include <windows.h>
/*------------------------------------------------------------------------
 Procedure:     LibMain ID:1
 Purpose:       Dll entry point.Called when a dll is loaded or
                unloaded by a process, and when new threads are
                created or destroyed.
 Input:         hDllInst: Instance handle of the dll
                fdwReason: event: attach/detach
                lpvReserved: not used
 Output:        The return value is used only when the fdwReason is
                DLL_PROCESS_ATTACH. True means that the dll has
                sucesfully loaded, False means that the dll is unable
                to initialize and should be unloaded immediately.
 Errors:
------------------------------------------------------------------------*/
BOOL WINAPI __declspec(dllexport) LibMain(HINSTANCE hDLLInst, DWORD fdwReason, LPVOID lpvReserved)
{
    switch (fdwReason)
    {
        case DLL_PROCESS_ATTACH:
            // The DLL is being loaded for the first time by a given process.
            // Perform per-process initialization here.  If the initialization
            // is successful, return TRUE; if unsuccessful, return FALSE.


            break;
        case DLL_PROCESS_DETACH:
            // The DLL is being unloaded by a given process.  Do any
            // per-process clean up here, such as undoing what was done in
            // DLL_PROCESS_ATTACH.  The return value is ignored.


            break;
        case DLL_THREAD_ATTACH:
            // A thread is being created in a process that has already loaded
            // this DLL.  Perform any per-thread initialization here.  The
            // return value is ignored.

            break;
        case DLL_THREAD_DETACH:
            // A thread is exiting cleanly in a process that has already
            // loaded this DLL.  Perform any per-thread clean up here.  The
            // return value is ignored.

            break;
    }
    return TRUE;
}

int __declspec(dllexport) cycletest(double a, double b)	/*gibt als Ergebnis true oder false,*/
					  /*true:  Punkt liegt auerhalb der Menge*/
 {
 double u,t;
    if (a > -0.75) {
    u = a - 0.25;
    t = u*u + b*b;
    return((2*t+u)*(2*t+u) > t);
    }
    else return((a+1)*(a+1) + b*b) > 0.0625;
 }


int __declspec(dllexport) iterate(double a, double b, int iter)

{
double x=0,y=0,xx=0;
int zaehler=1;

	     while( (zaehler<=iter) && ( x*x+y*y < 4) ) {
		      zaehler++;
		      xx=x*x-y*y+a;
		      y=2*x*y+b;
		      x=xx;
		  }

	     if(zaehler<=iter)  return zaehler;
	     else return(0);

}
